/*
	File:		SITestClasses.h

	Contains:	Declarations to test the LibraryBuilder app for SI-type classes

	Copyright:	 1992-1994 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __LIBRARYMANAGERCLASSES__
#include <LibraryManagerClasses.h>
#endif

extern void InitTestLibrary();
extern unsigned short GetStateValue();

/*******************************************************************************
** Class TNVTest1
********************************************************************************/

#define kTNVTest1ID "quin:test$NVTest1,1.2"

class TNVTest1
{
	public:
						_CDECL TNVTest1();
						~_CDECL TNVTest1();
		
				int		_CDECL NVTest1(int, int);
				int		_CDECL NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TNVTest2
********************************************************************************/

#define kTNVTest2ID "quin:test$NVTest2,1.2"

class TNVTest2 : public TNVTest1
{
	public:
						_CDECL TNVTest2();
						~_CDECL TNVTest2();
		
				int		_CDECL NVTest3(int, int);
				int		_CDECL NVTest4(int, int);
				
	private:
		int		fField2;
};

/*******************************************************************************
** Class TSITest1
********************************************************************************/

#define kTSITest1ID "quin:test$SITest1,1.2"

class TSITest1 : public TDynamic
{
	public:
						_CDECL TSITest1();
		virtual			~_CDECL TSITest1();
		
		virtual int		_CDECL VTest1(int, int);
		virtual int		_CDECL VTest2(int, int);
			
				int		_CDECL NVTest1(int, int);
				int		_CDECL NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TSITest2
********************************************************************************/

#define kTSITest2ID "quin:test$SITest2,1.2"

#if SINGLEOBJECT
class TSITest2 : public SingleObject
#else
class TSITest2
#endif
{
	ASLM_COMPATIBLE

	public:
						_CDECL TSITest2();
		virtual			~_CDECL TSITest2();
		
		virtual int		_CDECL VTest1(int, int);
		virtual int		_CDECL VTest2(int, int);
			
				int		_CDECL NVTest1(int, int);
				int		_CDECL NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TSITest3
**
** The Symantec C++ version does not have _machdl on it, because if you 
** #include <GlobalNew.h> - the compiler uses the overridden version - which
** does not give you a handle.  The results are ugly!
********************************************************************************/

#define kTSITest3ID "quin:test$SITest3,1.2"

#if SINGLEOBJECT
class TSITest3 : public HandleObject
#else
class TSITest3
#endif
{
	ASLM_COMPATIBLE

	public:
						_CDECL TSITest3();
		virtual			~_CDECL TSITest3();
		
		virtual int		_CDECL VTest1(int, int);
		virtual int		_CDECL VTest2(int, int);
			
				int		_CDECL NVTest1(int, int);
				int		_CDECL NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TSITest4
********************************************************************************/

#define kTSITest4ID "quin:test$SITest4,1.2"

class TSITest4
{
	ASLM_COMPATIBLE

	public:
						_CDECL TSITest4();
		virtual			~_CDECL TSITest4();
		
		virtual int		_CDECL VTest1(int, int);
		virtual int		_CDECL VTest2(int, int);
		virtual int		_CDECL VTest3(int, int);
		virtual int		_CDECL VTest4(int, int);
			
				int		_CDECL NVTest1(int, int);
				int		_CDECL NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TSITest5
********************************************************************************/

#define kTSITest5ID "quin:test$SITest5,1.2"

class TSITest5 : public TSITest4
{
	public:
						_CDECL TSITest5();
		virtual			~_CDECL TSITest5();
		
		virtual int		_CDECL VTest1(int, int);
		virtual int		_CDECL VTest2(int, int);
		virtual int		_CDECL VTest4(int, int);
			
				int		_CDECL NVTest1(int, int);
				int		_CDECL NVTest2(int, int);
				
	private:
		int		fField2;
};

